// MineSweeper.h: interface for the CMineSweeper class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MINESWEEPER_H__CB17FE3A_9BB3_4033_8A89_CBCD87F19EF8__INCLUDED_)
#define AFX_MINESWEEPER_H__CB17FE3A_9BB3_4033_8A89_CBCD87F19EF8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ActionHandler.h"

#define SIZE 30

class CMineSweeper: public CActionHandler
{
    enum OpenStatus {unopened, flagged, questioned, opened};
    enum RunningStatus {ready, running, halt};

public:
	CMineSweeper(CGraphicOutput *pGO);
	virtual ~CMineSweeper();

public:
    void cellOpen(int irow, int icol);
    void cellMark(int irow, int icol);
    void newGame(int width, int height, int mineCount);
    void exitProgram();

private:
    void deployMines();

private:
    int m_mines[SIZE][SIZE];
    int m_unOpenedCells;
    OpenStatus m_openStatus[SIZE][SIZE];
    int m_width;
    int m_height;
    int m_mineCount;
    int m_mineCountOriginal;
    RunningStatus m_running;
};

#endif // !defined(AFX_MINESWEEPER_H__CB17FE3A_9BB3_4033_8A89_CBCD87F19EF8__INCLUDED_)
