// win32mineDoc.cpp : implementation of the CWin32mineDoc class
//

#include "stdafx.h"
#include "win32mine.h"

#include "../ActionHandler.h"
#include "win32mineDoc.h"

#include "MainFrm.h"
#include "win32mineView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWin32mineDoc

IMPLEMENT_DYNCREATE(CWin32mineDoc, CDocument)

BEGIN_MESSAGE_MAP(CWin32mineDoc, CDocument)
	//{{AFX_MSG_MAP(CWin32mineDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
    ON_COMMAND(IDM_NEWGAME, OnNewgame)
    ON_COMMAND(IDM_BEGINNER, OnBeginner)
    ON_UPDATE_COMMAND_UI(IDM_BEGINNER, OnUpdateBeginner)
    ON_COMMAND(IDM_INTERMEDIATE, OnIntermediate)
    ON_UPDATE_COMMAND_UI(IDM_INTERMEDIATE, OnUpdateIntermediate)
    ON_COMMAND(IDM_ADVANCED, OnAdvanced)
    ON_UPDATE_COMMAND_UI(IDM_ADVANCED, OnUpdateAdvanced)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWin32mineDoc construction/destruction

CWin32mineDoc::CWin32mineDoc():
    m_width(BEGINNERWIDTH), 
    m_height(BEGINNERHEIGHT), 
    m_mineCountOriginal(10),
    m_mineCount(0),
    m_level(IDM_BEGINNER),
    m_resetStatus(IDB_SMILE1),
    m_clockTicks(0)
{
    int i, j;
    for (i=0; i<m_height; i++)
        for (j=0; j<m_width; j++)
            m_cells[i][j] = IDB_CELL;
}

CWin32mineDoc::~CWin32mineDoc()
{
}

BOOL CWin32mineDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)
    SetTitle("ap");
//  OnNewgame(); // handler is not ready at this moment
    m_resetStatus = IDB_SMILE1;
    m_clockTicks = 0;

    return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CWin32mineDoc serialization

void CWin32mineDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CWin32mineDoc diagnostics

#ifdef _DEBUG
void CWin32mineDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CWin32mineDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CWin32mineDoc commands

// width of the game board

int CWin32mineDoc::GetBoardWidth(void)
{
    return m_width;
}

// height of the game board
int CWin32mineDoc::GetBoardHeight(void)
{
    return m_height;
}

CELLROWPTR CWin32mineDoc::GetCells(void)
{
    return m_cells;
}

int CWin32mineDoc::GetMineCount(void)
{
    return m_mineCount;
}

int CWin32mineDoc::GetResetStatus(void)
{
    return m_resetStatus;
}

int CWin32mineDoc::GetClockTicks(void)
{
    return m_clockTicks;
}

void CWin32mineDoc::resetBtnPressed(void)
{
    switch (m_resetStatus)
    {
    case IDB_FRAWN1:
        m_resetStatus = IDB_FRAWN0;
        break;
    case IDB_SMILE1:
        m_resetStatus = IDB_SMILE0;
        break;
    }
    UpdateAllViews(0);
}

void CWin32mineDoc::resetBtnReleased(void)
{
    switch (m_resetStatus)
    {
    case IDB_FRAWN0:
        m_resetStatus = IDB_FRAWN1;
        break;
    case IDB_SMILE0:
        m_resetStatus = IDB_SMILE1;
        break;
    }
    UpdateAllViews(0);
}

void CWin32mineDoc::SetBoardSize(int width, int height)
{
    int i, j;
    m_width = width;
    m_height = height;
    for (i=0; i<m_height; i++)
        for (j=0; j<m_width; j++)
            m_cells[i][j] = IDB_CELL;

    UpdateAllViews(0, 1); // recalculate the window width and height
}

void CWin32mineDoc::OnNewgame()
{
    // TODO: b[JzROBz`{X

    SetBoardSize(m_width, m_height);
    m_mineCount = m_mineCountOriginal;

    m_handler->newGame(m_width, m_height, m_mineCount);
}

void CWin32mineDoc::OnBeginner()
{
    // TODO: b[JzROBz`{X
    m_level = IDM_BEGINNER;
    SetBoardSize(9, 9);
    m_mineCountOriginal = 10;
    m_mineCount = m_mineCountOriginal;

    m_handler->newGame(m_width, m_height, m_mineCount);
}

void CWin32mineDoc::OnUpdateBeginner(CCmdUI *pCmdUI)
{
    // TODO: b[JzROs UI Bz`{X
    if (m_level == IDM_BEGINNER)
        pCmdUI->SetCheck();
    else
        pCmdUI->SetCheck(FALSE);
}

void CWin32mineDoc::OnIntermediate()
{
    // TODO: b[JzROBz`{X
    m_level = IDM_INTERMEDIATE;
    SetBoardSize(16, 16);
    m_mineCountOriginal = 40;
    m_mineCount = m_mineCountOriginal;

    m_handler->newGame(m_width, m_height, m_mineCount);
}

void CWin32mineDoc::OnUpdateIntermediate(CCmdUI *pCmdUI)
{
    // TODO: b[JzROs UI Bz`{X
    if (m_level == IDM_INTERMEDIATE)
        pCmdUI->SetCheck();
    else
        pCmdUI->SetCheck(FALSE);
}

void CWin32mineDoc::OnAdvanced()
{
    // TODO: b[JzROBz`{X
    m_level = IDM_ADVANCED;
    SetBoardSize(30, 16);
    m_mineCountOriginal = 99;
    m_mineCount = m_mineCountOriginal;

    m_handler->newGame(m_width, m_height, m_mineCount);
}

void CWin32mineDoc::OnUpdateAdvanced(CCmdUI *pCmdUI)
{
    // TODO: b[JzROs UI Bz`{X
    if (m_level == IDM_ADVANCED)
        pCmdUI->SetCheck();
    else
        pCmdUI->SetCheck(FALSE);
}

// ---------------------------------------------------

void CWin32mineDoc::showFrawn()
{
    m_resetStatus = IDB_FRAWN1;
    UpdateAllViews(0);
}

void CWin32mineDoc::showSmile()
{
    m_resetStatus = IDB_SMILE1;
    UpdateAllViews(0);
}

void CWin32mineDoc::showCell(int irow, int icol)
{
    m_cells[irow][icol] = IDB_CELL;
    UpdateAllViews(0);
}

void CWin32mineDoc::showFlag(int irow, int icol)
{
    m_cells[irow][icol] = IDB_FLAG;
    UpdateAllViews(0);
}

void CWin32mineDoc::showBlastedMine(int irow, int icol)
{
    m_cells[irow][icol] = IDB_BLASTEDMINE;
    UpdateAllViews(0);
}

void CWin32mineDoc::showMine(int irow, int icol)
{
    m_cells[irow][icol] = IDB_MINE;
    UpdateAllViews(0);
}

void CWin32mineDoc::showQuestionMark(int irow, int icol)
{
    m_cells[irow][icol] = IDB_QMARK;
    UpdateAllViews(0);
}

void CWin32mineDoc::showSurroundingMineCount(int count, int irow, int icol)
{
    switch (count)
    {
    case 0:
        m_cells[irow][icol] = IDB_OC0;
        break;
    case 1:
        m_cells[irow][icol] = IDB_OC1;
        break;
    case 2:
        m_cells[irow][icol] = IDB_OC2;
        break;
    case 3:
        m_cells[irow][icol] = IDB_OC3;
        break;
    case 4:
        m_cells[irow][icol] = IDB_OC4;
        break;
    case 5:
        m_cells[irow][icol] = IDB_OC5;
        break;
    case 6:
        m_cells[irow][icol] = IDB_OC6;
        break;
    case 7:
        m_cells[irow][icol] = IDB_OC7;
        break;
    case 8:
        m_cells[irow][icol] = IDB_OC8;
        break;
    }
    UpdateAllViews(0);
}

void CWin32mineDoc::setRemainingMineCount(int count)
{
    m_mineCount = count;
    UpdateAllViews(0);
}

void CWin32mineDoc::startClock()
{
    CFrameWnd *pFrame = (CFrameWnd *) AfxGetMainWnd();
    if (pFrame) // this function might be called before main window being opened for its first time
    {
        CWin32mineView *pView = (CWin32mineView *)(pFrame->GetActiveView());
        pView->startTimer();
    }
}

void CWin32mineDoc::stopClock()
{
    CFrameWnd *pFrame = (CFrameWnd *) AfxGetMainWnd();
    if (pFrame) // this function might be called before main window being opened for its first time
    {
        CWin32mineView *pView = (CWin32mineView *)(pFrame->GetActiveView());
        pView->stopTimer();
    }
}

void CWin32mineDoc::resetClock()
{
    SetClock(0);
    stopClock();
}

CActionHandler *CWin32mineDoc::GetHandler(void)
{
    return m_handler;
}

void CWin32mineDoc::SetClock(int tick)
{
    m_clockTicks = tick;
    UpdateAllViews(0);
}

void CWin32mineDoc::OnCloseDocument()
{
    // TODO: b[JSw{XM () IsO

    m_handler->exitProgram();

    CDocument::OnCloseDocument();
}
