// win32mineDoc.h : interface of the CWin32mineDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_WIN32MINEDOC_H__3F971773_5274_4213_9751_D4B01D371D3D__INCLUDED_)
#define AFX_WIN32MINEDOC_H__3F971773_5274_4213_9751_D4B01D371D3D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "../GraphicOutput.h"

class CWin32mineDoc : public CDocument, public CGraphicOutput
{
protected: // create from serialization only
	CWin32mineDoc();
	DECLARE_DYNCREATE(CWin32mineDoc)

// Attributes
public:

// Operations
public:

public:
    // width of the game board
    int GetBoardWidth(void);
    // height of the game board
    int GetBoardHeight(void);

private:
    int m_cells[MAXBOARDSIZE][MAXBOARDSIZE];
    int m_mineCount;
    int m_resetStatus;
    int m_clockTicks;
    int m_level;
    int m_mineCountOriginal;
    int m_width;
    int m_height;

public:
    CELLROWPTR GetCells(void);
    int GetMineCount(void);
    int GetResetStatus(void);
    int GetClockTicks(void);
    void resetBtnPressed(void);
    void resetBtnReleased(void);
    void SetBoardSize(int width, int height);
    CActionHandler * GetHandler(void);
    void SetClock(int tick);

/* CGraphicOutput */
public:
    void showFrawn();
    void showSmile();
    void showCell(int irow, int icol);
    void showFlag(int irow, int icol);
    void showBlastedMine(int irow, int icol);
    void showMine(int irow, int icol);
    void showQuestionMark(int irow, int icol);
    void showSurroundingMineCount(int count, int irow, int icol);
    void setRemainingMineCount(int count);
    void startClock();
    void stopClock();
    void resetClock();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CWin32mineDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual void OnCloseDocument();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CWin32mineDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
public:
	//{{AFX_MSG(CWin32mineDoc)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
    afx_msg void OnNewgame();
    afx_msg void OnBeginner();
    afx_msg void OnUpdateBeginner(CCmdUI *pCmdUI);
    afx_msg void OnIntermediate();
    afx_msg void OnUpdateIntermediate(CCmdUI *pCmdUI);
    afx_msg void OnAdvanced();
    afx_msg void OnUpdateAdvanced(CCmdUI *pCmdUI);
    //}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_WIN32MINEDOC_H__3F971773_5274_4213_9751_D4B01D371D3D__INCLUDED_)
