// win32mineView.h : interface of the CWin32mineView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_WIN32MINEVIEW_H__FC08EFA4_0460_4EB7_B156_017F753EDA19__INCLUDED_)
#define AFX_WIN32MINEVIEW_H__FC08EFA4_0460_4EB7_B156_017F753EDA19__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CWin32mineView : public CView
{
protected: // create from serialization only
	CWin32mineView();
	DECLARE_DYNCREATE(CWin32mineView)

// Attributes
public:
	CWin32mineDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CWin32mineView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CWin32mineView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

public:
    virtual void OnInitialUpdate();
private:
    // calcualte the width and height in pixel of the window based on the width and the height of the game board
    void calculateWindowSize(int * windowWidth, int * windowHeight);

private:
    // cell[0][0]'s left, top
    CPoint m_cellOrg;
    CPoint m_mineCountOrg;
    CPoint m_clockOrg;
    CPoint m_resetBtnOrg;
    CSize m_cellSize;
    CSize m_resetBtnSize;
    // digit size of mine count and clock 
    CSize m_digitSize;
    UINT m_timer;

    void DrawCells(CDC* pDC, int cells[][MAXBOARDSIZE]);
    void DrawClock(CDC* pDC, int value);
    void DrawMineCount(CDC* pDC, int count);
    void DrawResetButton(CDC* pDC, int status);
    int DrawBitmap(CDC *pdc, int x, int y, int id);
    int hitTest(CPoint pt, int * cell_irow, int * cell_icol);

protected:
    virtual void OnUpdate(CView* /*pSender*/, LPARAM /*lHint*/, CObject* /*pHint*/);
public:
    virtual int OnToolHitTest(CPoint point, TOOLINFO* pTI) const;
    void startTimer(void);
    void stopTimer(void);
    void windowLayout(void);
private:

// Generated message map functions
protected:
	//{{AFX_MSG(CWin32mineView)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
    afx_msg BOOL OnEraseBkgnd(CDC* pDC);
    afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
    afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
    afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
    afx_msg BOOL OnToolTipNotify(UINT id, NMHDR *pNMHDR, LRESULT *pResult);
    afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in win32mineView.cpp
inline CWin32mineDoc* CWin32mineView::GetDocument()
   { return (CWin32mineDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_WIN32MINEVIEW_H__FC08EFA4_0460_4EB7_B156_017F753EDA19__INCLUDED_)
